@echo off
echo off
rem (C) Copyright 1993, Ad Infinitum Programs, all rights reserved

rem U2_EXARJ.BAT accepts a single parameter: an archive file. It
rem decompresses all files (including hidden ones, etc.) of this archive
rem completely into the current directory. If nothing goes wrong, the files
rem U$~CHK1 and U$~CHK2 are created by this batch file. UC tests for the
rem presence of those files.

rem 1. ARJ

rem ***  ARJ  ***

   rem Add file to archive

      echo check > u$~chk1
      ARJ a %1 u$~chk1

   rem Errorlevel 4 means the archive cannot be updated (security envelope).
   rem Because of an internal error in ARJ this currently is errorlevel 2.

      if errorlevel 2 goto special
      del u$~chk1

:special

   rem Expand archive

      ARJ x -y %1

   rem Test for correct expansion

      if errorlevel 1 goto error
      if not exist u$~chk1 goto error
      goto ok


:error
rem *** Error handling ***

   if exist u$~chk1 del u$~chk1
   if exist u$~chk2 del u$~chk2
   goto end


:ok
rem *** Expansion was successfull ***

   rem Call 'extra' file, allowing e.g. addition of banners

      command /cu2_xtra

   rem Create second check file to notify complete success to UC

      echo check > u$~chk2


:end
rem *** End of batchfile ***
