@echo off
echo off
rem (C) Copyright 1993, Ad Infinitum Programs, all rights reserved

rem U2_EXUCN.BAT accepts a single parameter: an archive file. It
rem decompresses all files (including hidden ones, etc.) of this archive
rem completely into the current directory. If nothing goes wrong, the files
rem U$~CHK1 and U$~CHK2 are created by this batch file. UC tests for the
rem presence of those files.

rem Notice that UCN files are handled just like UC2 files. The purpose is
rem to allow "conversion" from UCN to UC2 of files. The conversion may
rem include several operations you want to perform. (e.g. adding banner,
rem virus scanning)

rem 1. UC

rem ***  UC  ***

   rem *** WARNING: Only revision 0 (newest) files are extracted ***

   rem Add file to archive

      echo check > u$$chk1
      uc a %1 u$$chk1
      del u$$chk1

   rem Expand archive

      uc xsf %1
      ren u$$chk1 u$~chk1

   rem Test for correct expansion

      if errorlevel 1 goto error
      if not exist u$~chk1 goto error
      goto ok


:error
rem *** Error handling ***

   if exist u$~chk1 del u$~chk1
   if exist u$~chk2 del u$~chk2
   goto end


:ok
rem *** Expansion was successfull ***

   rem Call 'extra' file, allowing e.g. addition of banners

      command /cu2_xtra

   rem Create second check file to notify complete success to UC

      echo check > u$~chk2


:end
rem *** End of batchfile ***
